diff --git a/sql/sql_table.cc b/sql/sql_table.cc
index b991215..7bb293b 100644
--- a/sql/sql_table.cc
+++ b/sql/sql_table.cc
@@ -4628,7 +4628,8 @@ int create_table_impl(THD *thd,
                        const char *orig_db, const char *orig_table_name,
                        const char *db, const char *table_name,
                        const char *path,
-                       HA_CREATE_INFO *create_info,
+                       const DDL_options_st options,
+                       HA_CREATE_INFO &create_info,
                        Alter_info *alter_info,
                        int create_table_mode,
                        bool *is_trans,
@@ -4647,32 +4648,32 @@ int create_table_impl(THD *thd,
 
   if (thd->variables.sql_mode & MODE_NO_DIR_IN_CREATE)
   {
-    if (create_info->data_file_name)
+    if (create_info.data_file_name)
       push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                           WARN_OPTION_IGNORED, ER(WARN_OPTION_IGNORED),
                           "DATA DIRECTORY");
-    if (create_info->index_file_name)
+    if (create_info.index_file_name)
       push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                           WARN_OPTION_IGNORED, ER(WARN_OPTION_IGNORED),
                           "INDEX DIRECTORY");
-    create_info->data_file_name= create_info->index_file_name= 0;
+    create_info.data_file_name= create_info.index_file_name= 0;
   }
   else
-  if (error_if_data_home_dir(create_info->data_file_name,  "DATA DIRECTORY") ||
-      error_if_data_home_dir(create_info->index_file_name, "INDEX DIRECTORY")||
+  if (error_if_data_home_dir(create_info.data_file_name,  "DATA DIRECTORY") ||
+      error_if_data_home_dir(create_info.index_file_name, "INDEX DIRECTORY")||
       check_partition_dirs(thd->lex->part_info))
     goto err;
 
-  alias= table_case_name(create_info, table_name);
+  alias= table_case_name(&create_info, table_name);
 
   /* Check if table exists */
-  if (create_info->tmp_table())
+  if (create_info.tmp_table())
   {
     TABLE *tmp_table;
     if ((tmp_table= find_temporary_table(thd, db, table_name)))
     {
       bool table_creation_was_logged= tmp_table->s->table_creation_was_logged;
-      if (create_info->options & HA_LEX_CREATE_REPLACE)
+      if (options.or_replace())
       {
         bool is_trans;
         /*
@@ -4682,7 +4683,7 @@ int create_table_impl(THD *thd,
         if (drop_temporary_table(thd, tmp_table, &is_trans))
           goto err;
       }
-      else if (create_info->options & HA_LEX_CREATE_IF_NOT_EXISTS)
+      else if (options.if_not_exists())
         goto warn;
       else
       {
@@ -4700,7 +4701,7 @@ int create_table_impl(THD *thd,
       {
         thd->variables.option_bits|= OPTION_KEEP_LOG;
         thd->log_current_statement= 1;
-        create_info->table_was_deleted= 1;
+        create_info.table_was_deleted= 1;
       }
     }
   }
@@ -4708,13 +4709,13 @@ int create_table_impl(THD *thd,
   {
     if (!internal_tmp_table && ha_table_exists(thd, db, table_name))
     {
-      if (create_info->options & HA_LEX_CREATE_REPLACE)
+      if (options.or_replace())
       {
         TABLE_LIST table_list;
         table_list.init_one_table(db, strlen(db), table_name,
                                   strlen(table_name), table_name,
                                   TL_WRITE_ALLOW_WRITE);
-        table_list.table= create_info->table;
+        table_list.table= create_info.table;
 
         if (check_if_log_table(&table_list, TRUE, "CREATE OR REPLACE"))
           goto err;
@@ -4734,7 +4735,7 @@ int create_table_impl(THD *thd,
         */
         thd->variables.option_bits|= OPTION_KEEP_LOG;
         thd->log_current_statement= 1;
-        create_info->table_was_deleted= 1;
+        create_info.table_was_deleted= 1;
         DBUG_EXECUTE_IF("send_kill_after_delete", thd->killed= KILL_QUERY; );
 
         /*
@@ -4744,7 +4745,7 @@ int create_table_impl(THD *thd,
             restart_trans_for_tables(thd, thd->lex->query_tables))
           goto err;
       }
-      else if (create_info->options & HA_LEX_CREATE_IF_NOT_EXISTS)
+      else if (options.if_not_exists())
         goto warn;
       else
       {
@@ -4756,7 +4757,7 @@ int create_table_impl(THD *thd,
 
   THD_STAGE_INFO(thd, stage_creating_table);
 
-  if (check_engine(thd, orig_db, orig_table_name, create_info))
+  if (check_engine(thd, orig_db, orig_table_name, &create_info))
     goto err;
 
   if (create_table_mode == C_ASSISTED_DISCOVERY)
@@ -4766,7 +4767,7 @@ int create_table_impl(THD *thd,
     DBUG_ASSERT(alter_info->key_list.elements == 0);
 
     TABLE_SHARE share;
-    handlerton *hton= create_info->db_type;
+    handlerton *hton= create_info.db_type;
     int ha_err;
     Field *no_fields= 0;
 
@@ -4781,13 +4782,13 @@ int create_table_impl(THD *thd,
     /* prepare everything for discovery */
     share.field= &no_fields;
     share.db_plugin= ha_lock_engine(thd, hton);
-    share.option_list= create_info->option_list;
-    share.connect_string= create_info->connect_string;
+    share.option_list= create_info.option_list;
+    share.connect_string= create_info.connect_string;
 
     if (parse_engine_table_options(thd, hton, &share))
       goto err;
 
-    ha_err= hton->discover_table_structure(hton, thd, &share, create_info);
+    ha_err= hton->discover_table_structure(hton, thd, &share, &create_info);
 
     /*
       if discovery failed, the plugin will be auto-unlocked, as it
@@ -4808,30 +4809,30 @@ int create_table_impl(THD *thd,
   }
   else
   {
-    file= mysql_create_frm_image(thd, orig_db, orig_table_name, create_info,
+    file= mysql_create_frm_image(thd, orig_db, orig_table_name, &create_info,
                                  alter_info, create_table_mode, key_info,
                                  key_count, frm);
     if (!file)
       goto err;
-    if (rea_create_table(thd, frm, path, db, table_name, create_info,
+    if (rea_create_table(thd, frm, path, db, table_name, &create_info,
                          file, frm_only))
       goto err;
   }
 
-  create_info->table= 0;
-  if (!frm_only && create_info->tmp_table())
+  create_info.table= 0;
+  if (!frm_only && create_info.tmp_table())
   {
     /*
       Open a table (skipping table cache) and add it into
       THD::temporary_tables list.
     */
 
-    TABLE *table= open_table_uncached(thd, create_info->db_type, frm, path,
+    TABLE *table= open_table_uncached(thd, create_info.db_type, frm, path,
                                       db, table_name, true, true);
 
     if (!table)
     {
-      (void) rm_temporary_table(create_info->db_type, path);
+      (void) rm_temporary_table(create_info.db_type, path);
       goto err;
     }
 
@@ -4839,7 +4840,7 @@ int create_table_impl(THD *thd,
       *is_trans= table->file->has_transactions();
 
     thd->thread_specific_used= TRUE;
-    create_info->table= table;                  // Store pointer to table
+    create_info.table= table;                  // Store pointer to table
   }
 #ifdef WITH_PARTITION_STORAGE_ENGINE
   else if (thd->work_part_info && frm_only)
@@ -4900,7 +4901,7 @@ int create_table_impl(THD *thd,
 
 int mysql_create_table_no_lock(THD *thd,
                                 const char *db, const char *table_name,
-                                HA_CREATE_INFO *create_info,
+                                Table_specification_st &create_info,
                                 Alter_info *alter_info, bool *is_trans,
                                 int create_table_mode)
 {
@@ -4910,12 +4911,12 @@ int mysql_create_table_no_lock(THD *thd,
   char path[FN_REFLEN + 1];
   LEX_CUSTRING frm= {0,0};
 
-  if (create_info->tmp_table())
+  if (create_info.tmp_table())
     build_tmptable_filename(thd, path, sizeof(path));
   else
   {
     int length;
-    const char *alias= table_case_name(create_info, table_name);
+    const char *alias= table_case_name(&create_info, table_name);
     length= build_table_filename(path, sizeof(path) - 1, db, alias,
                                  "", 0);
     // Check if we hit FN_REFLEN bytes along with file extension.
@@ -4927,7 +4928,8 @@ int mysql_create_table_no_lock(THD *thd,
   }
 
   res= create_table_impl(thd, db, table_name, db, table_name, path,
-                         create_info, alter_info, create_table_mode,
+                         create_info, create_info,
+                         alter_info, create_table_mode,
                          is_trans, &not_used_1, &not_used_2, &frm);
   my_free(const_cast<uchar*>(frm.str));
   return res;
@@ -4944,7 +4946,7 @@ int mysql_create_table_no_lock(THD *thd,
 */
 
 bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
-                        HA_CREATE_INFO *create_info,
+                        Table_specification_st &create_info,
                         Alter_info *alter_info)
 {
   const char *db= create_table->db;
@@ -4960,10 +4962,10 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
 
   /* Copy temporarily the statement flags to thd for lock_table_names() */
   uint save_thd_create_info_options= thd->lex->create_info.options;
-  thd->lex->create_info.options|= create_info->options;
+  thd->lex->create_info.options|= create_info.options;
 
   /* Open or obtain an exclusive metadata lock on table being created  */
-  result= open_and_lock_tables(thd, create_table, FALSE, 0);
+  result= open_and_lock_tables(thd, create_info, create_table, FALSE, 0);
 
   thd->lex->create_info.options= save_thd_create_info_options;
 
@@ -4973,9 +4975,9 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
     DBUG_RETURN(thd->is_error());
   }
   /* The following is needed only in case of lock tables */
-  if ((create_info->table= create_table->table))
+  if ((create_info.table= create_table->table))
   {
-    pos_in_locked_tables= create_info->table->pos_in_locked_tables;
+    pos_in_locked_tables= create_info.table->pos_in_locked_tables;
     mdl_ticket= create_table->table->mdl_ticket;
   }
   
@@ -5000,7 +5002,7 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
     on a non temporary table
   */
   if (thd->locked_tables_mode && pos_in_locked_tables &&
-      (create_info->options & HA_LEX_CREATE_REPLACE))
+      create_info.or_replace())
   {
     /*
       Add back the deleted table and re-created table as a locked table
@@ -5021,13 +5023,13 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
 
 err:
   /* In RBR we don't need to log CREATE TEMPORARY TABLE */
-  if (thd->is_current_stmt_binlog_format_row() && create_info->tmp_table())
+  if (thd->is_current_stmt_binlog_format_row() && create_info.tmp_table())
     DBUG_RETURN(result);
 
   /* Write log if no error or if we already deleted a table */
   if (!result || thd->log_current_statement)
   {
-    if (result && create_info->table_was_deleted)
+    if (result && create_info.table_was_deleted)
     {
       /*
         Possible locked table was dropped. We should remove meta data locks
@@ -5035,13 +5037,13 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
       */
       thd->locked_tables_list.unlock_locked_table(thd, mdl_ticket);
     }
-    else if (!result && create_info->tmp_table() && create_info->table)
+    else if (!result && create_info.tmp_table() && create_info.table)
     {
       /*
         Remember that tmp table creation was logged so that we know if
         we should log a delete of it.
       */
-      create_info->table->s->table_creation_was_logged= 1;
+      create_info.table->s->table_creation_was_logged= 1;
     }
     if (write_bin_log(thd, result ? FALSE : TRUE, thd->query(),
                       thd->query_length(), is_trans))
@@ -5241,9 +5243,9 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
 
 bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
                              TABLE_LIST* src_table,
-                             HA_CREATE_INFO *create_info)
+                             Table_specification_st &create_info)
 {
-  HA_CREATE_INFO local_create_info;
+  Table_specification_st local_create_info;
   TABLE_LIST *pos_in_locked_tables= 0;
   Alter_info local_alter_info;
   Alter_table_ctx local_alter_ctx; // Not used
@@ -5256,7 +5258,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
 
 #ifdef WITH_WSREP
   if (WSREP_ON && !thd->wsrep_applier &&
-      wsrep_create_like_table(thd, table, src_table, create_info))
+      wsrep_create_like_table(thd, table, src_table, &create_info))
     DBUG_RETURN(res);
 #endif
 
@@ -5273,9 +5275,10 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
   */
 
   /* Copy temporarily the statement flags to thd for lock_table_names() */
+  // QQ: is this really needed???
   uint save_thd_create_info_options= thd->lex->create_info.options;
-  thd->lex->create_info.options|= create_info->options;
-  res= open_tables(thd, &thd->lex->query_tables, &not_used, 0);
+  thd->lex->create_info.options|= create_info.options;
+  res= open_tables(thd, create_info, &thd->lex->query_tables, &not_used, 0);
   thd->lex->create_info.options= save_thd_create_info_options;
 
   if (res)
@@ -5285,8 +5288,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
     goto err;
   }
   /* Ensure we don't try to create something from which we select from */
-  if ((create_info->options & HA_LEX_CREATE_REPLACE) &&
-      !create_info->tmp_table())
+  if (create_info.or_replace() && !create_info.tmp_table())
   {
     TABLE_LIST *duplicate;
     if ((duplicate= unique_table(thd, table, src_table, 0)))
@@ -5300,8 +5302,12 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
 
   DEBUG_SYNC(thd, "create_table_like_after_open");
 
-  /* Fill HA_CREATE_INFO and Alter_info with description of source table. */
-  bzero((char*) &local_create_info, sizeof(local_create_info));
+  /*
+    Fill Table_specification_st and Alter_info with the source table description.
+    Set OR REPLACE and IF NOT EXISTS option as in the CREATE TABLE LIKE
+    statement.
+  */
+  local_create_info.init(create_info.create_like_options());
   local_create_info.db_type= src_table->table->s->db_type();
   local_create_info.row_type= src_table->table->s->row_type;
   if (mysql_prepare_alter_table(thd, src_table->table, &local_create_info,
@@ -5322,13 +5328,9 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
   */
   if (src_table->schema_table)
     local_create_info.max_rows= 0;
-  /* Set IF NOT EXISTS option as in the CREATE TABLE LIKE statement. */
-  local_create_info.options|= (create_info->options &
-                               (HA_LEX_CREATE_IF_NOT_EXISTS | 
-                                HA_LEX_CREATE_REPLACE));
   /* Replace type of source table with one specified in the statement. */
   local_create_info.options&= ~HA_LEX_CREATE_TMP_TABLE;
-  local_create_info.options|= create_info->tmp_table();
+  local_create_info.options|= create_info.tmp_table();
   /* Reset auto-increment counter for the new table. */
   local_create_info.auto_increment_value= 0;
   /*
@@ -5343,7 +5345,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
 
   res= ((create_res=
          mysql_create_table_no_lock(thd, table->db, table->table_name,
-                                    &local_create_info, &local_alter_info,
+                                    local_create_info, &local_alter_info,
                                     &is_trans, C_ORDINARY_CREATE)) > 0);
   /* Remember to log if we deleted something */
   do_logging= thd->log_current_statement;
@@ -5355,7 +5357,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
     on a non temporary table
   */
   if (thd->locked_tables_mode && pos_in_locked_tables &&
-      (create_info->options & HA_LEX_CREATE_REPLACE))
+      create_info.or_replace())
   {
     /*
       Add back the deleted table and re-created table as a locked table
@@ -5383,7 +5385,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
       Ensure that we have an exclusive lock on target table if we are creating
       non-temporary table.
     */
-    DBUG_ASSERT((create_info->tmp_table()) ||
+    DBUG_ASSERT((create_info.tmp_table()) ||
                 thd->mdl_context.is_lock_owner(MDL_key::TABLE, table->db,
                                                table->table_name,
                                                MDL_EXCLUSIVE));
@@ -5412,7 +5414,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
            4    temporary temporary Nothing
            ==== ========= ========= ==============================
     */
-    if (!(create_info->tmp_table()))
+    if (!(create_info.tmp_table()))
     {
       if (src_table->table->s->tmp_table)               // Case 2
       {
@@ -5465,7 +5467,8 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
         if (!table->view)
         {
           int result __attribute__((unused))=
-            show_create_table(thd, table, &query, create_info, WITHOUT_DB_NAME);
+            show_create_table(thd, table, &query,
+                              &create_info, WITHOUT_DB_NAME);
 
           DBUG_ASSERT(result == 0); // show_create_table() always return 0
           do_logging= FALSE;
@@ -5499,8 +5502,8 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
   {
     DBUG_PRINT("info",
                ("res: %d  tmp_table: %d  create_info->table: %p",
-                res, create_info->tmp_table(), local_create_info.table));
-    if (!res && create_info->tmp_table() && local_create_info.table)
+                res, create_info.tmp_table(), local_create_info.table));
+    if (!res && create_info.tmp_table() && local_create_info.table)
     {
       /*
         Remember that tmp table creation was logged so that we know if
@@ -5514,7 +5517,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
 err:
   if (do_logging)
   {
-    if (res && create_info->table_was_deleted)
+    if (res && create_info.table_was_deleted)
     {
       /*
         Table was not deleted. Original table was deleted.
@@ -5522,7 +5525,7 @@ bool mysql_create_like_table(THD* thd, TABLE_LIST* table,
       */
       log_drop_table(thd, table->db, table->db_length,
                      table->table_name, table->table_name_length,
-                     create_info->tmp_table());
+                     create_info.tmp_table());
     }
     else if (write_bin_log(thd, res ? FALSE : TRUE, thd->query(),
                            thd->query_length(), is_trans))
@@ -5918,7 +5921,7 @@ static bool is_candidate_key(KEY *key)
   
 #ifdef WITH_PARTITION_STORAGE_ENGINE
   partition_info *tab_part_info= table->part_info;
-  if (tab_part_info && thd->lex->check_exists)
+  if (tab_part_info && thd->lex->if_exists())
   {
     /* ALTER TABLE ADD PARTITION IF NOT EXISTS */
     if (alter_info->flags & Alter_info::ALTER_ADD_PARTITION)
@@ -8645,7 +8648,7 @@ bool mysql_alter_table(THD *thd,char *new_db, char *new_name,
                            alter_ctx.db, alter_ctx.table_name,
                            alter_ctx.new_db, alter_ctx.tmp_name,
                            alter_ctx.get_tmp_path(),
-                           create_info, alter_info,
+                           thd->lex->create_info, *create_info, alter_info,
                            C_ALTER_TABLE_FRM_ONLY, NULL,
                            &key_info, &key_count, &frm);
   reenable_binlog(thd);
diff --git a/sql/sql_table.h b/sql/sql_table.h
index c3e903a..83a2e1a 100644
--- a/sql/sql_table.h
+++ b/sql/sql_table.h
@@ -31,6 +31,7 @@
 class handler;
 typedef struct st_ha_check_opt HA_CHECK_OPT;
 struct HA_CREATE_INFO;
+struct Table_specification_st;
 typedef struct st_key KEY;
 typedef struct st_key_cache KEY_CACHE;
 typedef struct st_lock_param_type ALTER_PARTITION_PARAM_TYPE;
@@ -151,7 +152,7 @@ uint build_table_shadow_filename(char *buff, size_t bufflen,
                                  ALTER_PARTITION_PARAM_TYPE *lpt);
 uint build_tmptable_filename(THD* thd, char *buff, size_t bufflen);
 bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
-                        HA_CREATE_INFO *create_info,
+                        Table_specification_st &create_info,
                         Alter_info *alter_info);
 
 /*
@@ -192,7 +193,7 @@ bool mysql_create_table(THD *thd, TABLE_LIST *create_table,
 
 int mysql_create_table_no_lock(THD *thd, const char *db,
                                const char *table_name,
-                               HA_CREATE_INFO *create_info,
+                               Table_specification_st &create_info,
                                Alter_info *alter_info, bool *is_trans,
                                int create_table_mode);
 
@@ -227,7 +228,7 @@ bool mysql_compare_tables(TABLE *table,
 bool mysql_recreate_table(THD *thd, TABLE_LIST *table_list, bool table_copy);
 bool mysql_create_like_table(THD *thd, TABLE_LIST *table,
                              TABLE_LIST *src_table,
-                             HA_CREATE_INFO *create_info);
+                             Table_specification_st &create_info);
 bool mysql_rename_table(handlerton *base, const char *old_db,
                         const char * old_name, const char *new_db,
                         const char * new_name, uint flags);
diff --git a/sql/sql_trigger.cc b/sql/sql_trigger.cc
index 443a82a..f404daa 100644
--- a/sql/sql_trigger.cc
+++ b/sql/sql_trigger.cc
@@ -444,7 +444,7 @@ bool mysql_create_or_drop_trigger(THD *thd, TABLE_LIST *tables, bool create)
 
   if (!create)
   {
-    bool if_exists= thd->lex->check_exists;
+    bool if_exists= thd->lex->if_exists();
 
     /*
       Protect the query table list from the temporary and potentially
diff --git a/sql/sql_view.cc b/sql/sql_view.cc
index 07169f2..b064546 100644
--- a/sql/sql_view.cc
+++ b/sql/sql_view.cc
@@ -1640,7 +1640,7 @@ bool mysql_drop_view(THD *thd, TABLE_LIST *views, enum_drop_mode drop_mode)
     {
       char name[FN_REFLEN];
       my_snprintf(name, sizeof(name), "%s.%s", view->db, view->table_name);
-      if (thd->lex->check_exists)
+      if (thd->lex->if_exists())
       {
 	push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
 			    ER_BAD_TABLE_ERROR, ER(ER_BAD_TABLE_ERROR),
diff --git a/sql/structs.h b/sql/structs.h
index 99561c5..b38685c 100644
--- a/sql/structs.h
+++ b/sql/structs.h
@@ -471,4 +471,67 @@ class Discrete_intervals_list {
   Discrete_interval* get_current() const { return current; };
 };
 
+
+struct DDL_options_st
+{
+public:
+  enum Options
+  {
+    OPT_NONE= 0,
+    OPT_IF_NOT_EXISTS= 2,              // CREATE TABLE IF NOT EXISTS
+    OPT_LIKE= 4,                       // CREATE TABLE LIKE
+    OPT_OR_REPLACE= 16,                // CREATE OR REPLACE TABLE
+    OPT_OR_REPLACE_SLAVE_GENERATED= 32,// REPLACE was added on slave, it was
+                                       // not in the original query on master.
+    OPT_IF_EXISTS= 64
+  };
+
+private:
+  Options m_options;
+
+protected:
+
+public:
+  Options create_like_options() const
+  {
+    return (DDL_options_st::Options)
+           (((uint) m_options) & (OPT_IF_NOT_EXISTS | OPT_OR_REPLACE));
+  }
+  void init() { m_options= OPT_NONE; }
+  void init(Options options) { m_options= options; }
+  void set(Options other)
+  {
+    m_options= other;
+  }
+  void set(const DDL_options_st other)
+  {
+    m_options= other.m_options;
+  }
+  bool if_not_exists() const { return m_options & OPT_IF_NOT_EXISTS; }
+  bool or_replace() const { return m_options & OPT_OR_REPLACE; }
+  bool or_replace_slave_generated() const
+  { return m_options & OPT_OR_REPLACE_SLAVE_GENERATED; }
+  bool like() const { return m_options & OPT_LIKE; }
+  bool if_exists() const { return m_options & OPT_IF_EXISTS; }
+  void add(const DDL_options_st::Options other)
+  {
+    m_options= (Options) ((uint) m_options | (uint) other);
+  }
+  void add(const DDL_options_st &other)
+  {
+    add(other.m_options);
+  }
+  DDL_options_st operator|(const DDL_options_st &other)
+  {
+    add(other.m_options);
+    return *this;
+  }
+  DDL_options_st operator|=(DDL_options_st::Options other)
+  {
+    add(other);
+    return *this;
+  }
+};
+
+
 #endif /* STRUCTS_INCLUDED */
diff --git a/sql/table.cc b/sql/table.cc
index 6ac4544..1e6f3ff 100644
--- a/sql/table.cc
+++ b/sql/table.cc
@@ -2061,7 +2061,7 @@ static bool sql_unusable_for_discovery(THD *thd, handlerton *engine,
   if (lex->sql_command != SQLCOM_CREATE_TABLE)
     return 1;
   // ... create like
-  if (create_info->options & HA_LEX_CREATE_TABLE_LIKE)
+  if (lex->create_info.like())
     return 1;
   // ... create select
   if (lex->select_lex.item_list.elements)
@@ -2070,7 +2070,7 @@ static bool sql_unusable_for_discovery(THD *thd, handlerton *engine,
   if (create_info->tmp_table())
     return 1;
   // ... if exists
-  if (create_info->options & HA_LEX_CREATE_IF_NOT_EXISTS)
+  if (lex->create_info.if_not_exists())
     return 1;
 
   // XXX error out or rather ignore the following:
@@ -3510,6 +3510,35 @@ bool check_db_name(LEX_STRING *org_name)
 }
 
 
+void SQL::Identifier_normalized::normalize()
+{
+  if (lower_case_table_names == 1 && name() != any_db)
+  {
+    CHARSET_INFO *cs= files_charset_info;
+    if (!check_mysql50_prefix(name()))
+    {
+      LEX_CSTRING::length= cs->cset->casedn(cs,
+                                            (char *) LEX_CSTRING::str,
+                                            LEX_CSTRING::length,
+                                            m_buf, sizeof(m_buf) - 1);
+    }
+    else
+    {
+      memcpy(m_buf, LEX_CSTRING::str, MYSQL50_TABLE_NAME_PREFIX_LENGTH);
+      LEX_CSTRING src;
+      src.str= name() + MYSQL50_TABLE_NAME_PREFIX_LENGTH;
+      src.length= name_length() - MYSQL50_TABLE_NAME_PREFIX_LENGTH;
+      LEX_CSTRING::length= MYSQL50_TABLE_NAME_PREFIX_LENGTH +
+        cs->cset->casedn(cs, (char *) src.str, src.length,
+                         m_buf + MYSQL50_TABLE_NAME_PREFIX_LENGTH,
+                         sizeof(m_buf) - MYSQL50_TABLE_NAME_PREFIX_LENGTH - 1);
+    }
+    LEX_CSTRING::str= m_buf;
+    m_buf[LEX_CSTRING::length]= '\0';
+  }
+}
+
+
 /*
   Allow anything as a table name, as long as it doesn't contain an
   ' ' at the end
diff --git a/sql/wsrep_mysqld.cc b/sql/wsrep_mysqld.cc
index 81b1e18..6a2d394 100644
--- a/sql/wsrep_mysqld.cc
+++ b/sql/wsrep_mysqld.cc
@@ -2364,7 +2364,7 @@ bool wsrep_create_like_table(THD* thd, TABLE_LIST* table,
         break;
       }
   }
-  if (create_info->options & HA_LEX_CREATE_TMP_TABLE)
+  if (create_info->tmp_table())
   {
 
     /* CREATE TEMPORARY TABLE LIKE must be skipped from replication */
diff --git a/storage/innobase/handler/ha_innodb.cc b/storage/innobase/handler/ha_innodb.cc
index 8154c0f..7598da2 100644
--- a/storage/innobase/handler/ha_innodb.cc
+++ b/storage/innobase/handler/ha_innodb.cc
@@ -10713,7 +10713,7 @@ static __attribute__((nonnull, warn_unused_result))
 
 	/* Do not use DATA DIRECTORY with TEMPORARY TABLE. */
 	if (create_info->data_file_name
-	    && create_info->options & HA_LEX_CREATE_TMP_TABLE) {
+	    && create_info->tmp_table()) {
 		push_warning(
 			thd, Sql_condition::WARN_LEVEL_WARN,
 			ER_ILLEGAL_HA_CREATE_OPTION,
@@ -10808,7 +10808,7 @@ static __attribute__((nonnull, warn_unused_result))
 
 	if (use_tablespace
 	    && !mysqld_embedded
-	    && !(create_info->options & HA_LEX_CREATE_TMP_TABLE)) {
+	    && !create_info->tmp_table()) {
 
 		if ((name[1] == ':')
 		    || (name[0] == '\\' && name[1] == '\\')) {
@@ -10826,7 +10826,7 @@ static __attribute__((nonnull, warn_unused_result))
 	In the case of;
 	  CREATE TEMPORARY TABLE ... DATA DIRECTORY={path} ... ;
 	We ignore the DATA DIRECTORY. */
-	if (create_info->options & HA_LEX_CREATE_TMP_TABLE) {
+	if (create_info->tmp_table()) {
 		strncpy(temp_path, name, FN_REFLEN - 1);
 	}
 
@@ -10844,7 +10844,7 @@ static __attribute__((nonnull, warn_unused_result))
 		}
 
 		/* Do not use DATA DIRECTORY with TEMPORARY TABLE. */
-		if (create_info->options & HA_LEX_CREATE_TMP_TABLE) {
+		if (create_info->tmp_table()) {
 			push_warning(
 				thd, Sql_condition::WARN_LEVEL_WARN,
 				ER_ILLEGAL_HA_CREATE_OPTION,
@@ -10916,7 +10916,7 @@ static __attribute__((nonnull, warn_unused_result))
 
 			/* We don't support FTS indexes in temporary
 			tables. */
-			if (create_info->options & HA_LEX_CREATE_TMP_TABLE) {
+			if (create_info->tmp_table()) {
 
 				my_error(ER_INNODB_NO_FT_TEMP_TABLE, MYF(0));
 				DBUG_RETURN(false);
@@ -11095,7 +11095,7 @@ static __attribute__((nonnull, warn_unused_result))
 
 	use_data_dir = use_tablespace
 		       && ((create_info->data_file_name != NULL)
-		       && !(create_info->options & HA_LEX_CREATE_TMP_TABLE));
+		       && !create_info->tmp_table());
 
 	/* Set up table dictionary flags */
 	dict_tf_set(flags,
@@ -11107,7 +11107,7 @@ static __attribute__((nonnull, warn_unused_result))
 		        default_compression_level : options->page_compression_level,
 		    options->atomic_writes);
 
-	if (create_info->options & HA_LEX_CREATE_TMP_TABLE) {
+	if (create_info->tmp_table()) {
 		*flags2 |= DICT_TF2_TEMPORARY;
 	}
 
@@ -11466,7 +11466,7 @@ static __attribute__((nonnull, warn_unused_result))
 	if (stmt) {
 		dberr_t	err = row_table_add_foreign_constraints(
 			trx, stmt, stmt_len, norm_name,
-			create_info->options & HA_LEX_CREATE_TMP_TABLE);
+			create_info->tmp_table());
 
 		switch (err) {
 
diff --git a/storage/spider/ha_spider.cc b/storage/spider/ha_spider.cc
index 03fa644..ccfb04f 100644
--- a/storage/spider/ha_spider.cc
+++ b/storage/spider/ha_spider.cc
@@ -10493,8 +10493,7 @@ int ha_spider::create(
     goto error;
   DBUG_PRINT("info",("spider tmp_table=%d", form->s->tmp_table));
   if (
-    (sql_command == SQLCOM_CREATE_TABLE &&
-      !(info->options & HA_LEX_CREATE_TMP_TABLE))
+    (sql_command == SQLCOM_CREATE_TABLE && !info->tmp_table())
   ) {
     if (
       !(table_tables = spider_open_sys_table(
